import { world, system, Vector } from "@minecraft/server";
import {
    ActionFormData,
    MessageFormData,
    ModalFormData
} from "@minecraft/server-ui";

world.afterEvents.itemUse.subscribe((data) => {
    const item = data.itemStack;
    const player = data.source;

    if (item.typeId == "ox:tppotion") {
        let inventory = player.getComponent("minecraft:inventory").container;
        let selectcoin = "ox:tppotion";
        let amount = 0;
        for (let i = 0; i < inventory.size; i++) {
            const item = inventory.getItem(i);
            if (!item || item.typeId != selectcoin) continue;
            amount += item.amount;
        }

        const handItem = player.getComponent("equippable").getEquipment("Mainhand");
        if (handItem.typeId == "ox:tppotion") {
            system.runTimeout(() => {
                let playerTags = player.getTags();
                let playerTpTags = player.getTags().length;

                let tptags = 0;

                let tpinfo = "";
                let xs = "";
                let ys = "";
                let zs = "";
                let tpdim = "";
                let tpentityshow = "";
                for (let i = 0; i <= playerTpTags; i++) {
                    if (!playerTags[i] == "") {
                        if (playerTags[i].startsWith("῟", 0)) {
                            tpinfo = playerTags[i].split("῝");
                            tptags = tptags + 1;
                            xs = Math.round(tpinfo[1]);
                            ys = Math.round(tpinfo[2]);
                            zs = Math.round(tpinfo[3]);
                            tpdim = world.getDimension(tpinfo[4]);
                            tpentityshow = tpdim.getEntities({
                                location: { x: xs, y: ys, z: zs },
                                maxDistance: 2,
                                type: "ox:teleportentity"
                            })[0]

                            if (tpentityshow?.nameTag == undefined) {
                                player.removeTag(playerTags[i]);
                            }
                        }
                    }
                }
                let inventoryA = player.getComponent("minecraft:inventory").container;
                let selectcoinA = "ox:tppotion";
                let amountA = 0;
                for (let i = 0; i < inventoryA.size; i++) {
                    const itemA = inventoryA.getItem(i);
                    if (!itemA || itemA.typeId != selectcoinA) continue;
                    amountA += itemA.amount;
                }
                const handItem2 = player.getComponent("equippable").getEquipment("Mainhand");

                if (handItem2 == undefined && amountA < amount && tptags != 0 && playerTpTags != 0 && tpentityshow?.nameTag != undefined) {
                    player.runCommandAsync('/kill @e [type=item,name="§l§dTeleportation §fPotion",r=8,c=1]');
                    player.runCommandAsync("/playanimation @s animation.tpplayer ");
                    player.runCommandAsync("/playsound portal.trigger @a [r=7]");
                    player.runCommandAsync("/camera @s fade time 4 0.6 1");
                    system.runTimeout(() => {
                        player.runCommandAsync("/effect @s levitation 4 1 true");
                    }, 6);
                    system.runTimeout(() => {
                        player.runCommandAsync("/playsound tp.done @s");
                        player.runCommandAsync("/particle ox:playertp ~ ~3 ~");
                    }, 55);
                    system.runTimeout(() => {
                        let ytpto = Math.pow(tpinfo[2], 1);
                        ytpto = ytpto + 1;
                        player.runCommandAsync("/execute in " + tpinfo[4] + " run tp @s " + tpinfo[1] + " " + ytpto + " " + tpinfo[3] + " 0 0");
                        player.runCommandAsync('/tellraw @s {"rawtext":[{"text":" §l§fYou §dHave Been Teleported §dTo §f' + tpentityshow?.nameTag + '"}]}');
                    }, 80);
                } else if (handItem2 == undefined && amountA < amount && tptags == 0 || handItem2 == undefined && amountA < amount && playerTpTags == 0 || handItem2 == undefined && amountA < amount && tpentityshow?.nameTag == undefined) {
                    player.runCommandAsync('/titleraw @s actionbar {"rawtext":[{"text":" §l§fYou §dAre Not Linked With a §5Teleportation !!"}]}');
                    player.runCommandAsync("/replaceitem entity @s slot.weapon.mainhand 0 ox:tppotion 1 0 ");
                    player.runCommandAsync("playsound note.bass @s");
                    player.runCommandAsync('/kill @e [type=item,name="§l§dTeleportation §fPotion",r=8,c=1]');
                }
            }, 20);
        }
    }
});
///////////////////////////////////////////////////////////

world.afterEvents.playerPlaceBlock.subscribe((data) => {
    const block = data.block;
    const playertpitem = data.player;

    if (block.typeId == "ox:teleport") {
        playertpitem.runCommandAsync("/gamerule sendcommandfeedback false");

        let topblock = world.getDimension(block.dimension.id).getBlock({ x: block.location.x, y: block.location.y + 1, z: block.location.z });

        let tpentity = block.dimension.getEntities({ location: block.location, maxDistance: 20, type: 'ox:teleportentity' });

        if (topblock.typeId == "minecraft:air" && tpentity.length == 0) {
            playertpitem.runCommandAsync("/setblock " + block.location.x + " " + (block.location.y + 1) + " " + block.location.z + " ox:teleport_top");

            playertpitem.runCommandAsync("/scoreboard objectives add TpPlayer῁ dummy §l§dTeleport");
            playertpitem.runCommandAsync("/scoreboard objectives add TpDes῁ dummy");

            playertpitem.runCommandAsync("/playsound hit.amethyst_cluster @s");
            const formtp = new ModalFormData();

            formtp.title(" §l§5Teleportation");
            formtp.textField("" + "\n" + " §l§fDescription :  §7§o(Optional)" + "\n" + " ", "Write Here ...");
            formtp.textField("" + "\n" + " §l§fName Tag :" + "\n" + " ", "Write Here ...");
            formtp.dropdown("\n" + " §l§dPrivacy §fMode :" + "\n" + " ", [" §l§fPrivate", " §l§fPublic"], 1);

            formtp.show(playertpitem).then((response) => {
                if (response.canceled) {
                    playertpitem.runCommandAsync("/playsound break.amethyst_cluster @s");
                    playertpitem.runCommandAsync("/setblock " + block.location.x + " " + block.location.y + " " + block.location.z + " air destroy");
                    playertpitem.runCommandAsync("/setblock " + block.location.x + " " + (block.location.y + 1) + " " + block.location.z + " air destroy");
                }
                else {
                    let [textfieldec, textfield, dropdown] = response.formValues;
                    let textfieldname = "" + textfield;

                    const xco = block.location.x;
                    const yco = block.location.y;
                    const zco = block.location.z;

                    if (textfield != "" && textfield != " " && textfieldname.length <= 25) {
                        playertpitem.runCommandAsync("playsound random.pop2 @s");
                        const formsuretp = new MessageFormData();

                        formsuretp.title(" §e§lNote : §4Are You Sure ??");
                        if (dropdown == 0) {
                            formsuretp.body("§l§fDo You Want To Set §5" + textfield + "§r§l§f Here." + "\n" + "\n" + "§r §l§o§b(Private) §r§l§fOnly §l§e§oYOU §r§l§fCan Use it !!");
                        }
                        else if (dropdown == 1) {
                            formsuretp.body("§l§fDo You Want To Set §5" + textfield + "§r§l§f Here." + "\n" + "\n" + "§r §l§o§b(Public) §r§l§fAll Players Can Use it !!");
                        }
                        formsuretp.button2("");
                        formsuretp.button1("");

                        formsuretp.show(playertpitem).then((response) => {
                            if (response.selection == 0) {
                                playertpitem.runCommandAsync("/playsound break.amethyst_cluster @s");
                                playertpitem.runCommandAsync("/setblock " + block.location.x + " " + block.location.y + " " + block.location.z + " air destroy");
                                playertpitem.runCommandAsync("/setblock " + block.location.x + " " + (block.location.y + 1) + " " + block.location.z + " air destroy");
                            } else {

                                let dimname = "";
                                if (playertpitem.dimension.id == "minecraft:overworld") {
                                    dimname = " §l§aOVERWORLD";
                                } else if (playertpitem.dimension.id == "minecraft:nether") {
                                    dimname = " §l§cNETHER";
                                } else if (playertpitem.dimension.id == "minecraft:the_end") {
                                    dimname = " §l§eTHE END";
                                }

                                playertpitem.runCommandAsync('execute at @s if entity @e [family=teleport,r=20] run tellraw @s {"rawtext":[{"text":" §l§cThere is a §5TELEPORTATION §cVery Close To You !!"}]}');
                                playertpitem.runCommandAsync("execute at @s if entity @e [family=teleport,r=20] run playsound note.bass @s");

                                //
                                playertpitem.runCommandAsync("execute at @s unless entity @e [family=teleport,r=20] run camera @s set example:example_free ease 0.7 in_out_back pos " + xco + " " + (yco + 5) + " " + zco + " rot 90 0");
                                playertpitem.runCommandAsync("execute at @s unless entity @e [family=teleport,r=20] run /playanimation @s animation.react_bottom_3");
                                playertpitem.runCommandAsync("execute at @s unless entity @e [family=teleport,r=20] run playsound respawn_anchor.charge @a [r=10]");
                                playertpitem.runCommandAsync("execute at @s unless entity @e [family=teleport,r=20] run particle minecraft:knockback_roar_particle " + xco + " " + (yco + 1) + " " + zco + "");

                                playertpitem.runCommandAsync("execute at @s unless entity @e [family=teleport,r=20] run tag @s add canTP");
                                playertpitem.runCommandAsync('execute at @s unless entity @e [family=teleport,r=20] run summon ox:teleportentity ' + xco + ' ' + (yco + 0.1) + ' ' + zco + ' 0 0');//

                                system.runTimeout(() => {
                                    let tpentity2 = block.dimension.getEntities({ location: block.location, maxDistance: 0.8, type: 'ox:teleportentity' });
                                    tpentity2[0].getComponent("minecraft:health").setCurrentValue(401);
                                    tpentity2[0].nameTag = textfieldname;
                                }, 35);
                                playertpitem.runCommandAsync('execute as @s if entity @s [tag=canTP] run tag @e [type=ox:teleportentity,x=' + xco + ',y=' + yco + ',z=' + zco + ',r=1] add "Owner῁' + playertpitem.nameTag + '"');
                                playertpitem.runCommandAsync("execute as @s if entity @s [tag=canTP] run scoreboard players add @e [type=ox:teleportentity,x=" + xco + ",y=" + yco + ",z=" + zco + ",r=1] TpPlayer῁ 0");
                                playertpitem.runCommandAsync("execute as @s if entity @s [tag=canTP] run scoreboard players add @e [type=ox:teleportentity,x=" + xco + ",y=" + yco + ",z=" + zco + ",r=1] TpPlayer῁ 0");
                                if (textfieldec != "" && textfieldec != " ") {
                                    playertpitem.runCommandAsync('execute as @s if entity @s [tag=canTP] run tag @e [type=ox:teleportentity,x=' + xco + ',y=' + yco + ',z=' + zco + ',r=1] add "῁des῟' + textfieldec + '"');
                                    playertpitem.runCommandAsync("execute as @s if entity @s [tag=canTP] run scoreboard players add @e [type=ox:teleportentity,x=" + xco + ",y=" + yco + ",z=" + zco + ",r=1] TpDes῁ 1");
                                } else {
                                    playertpitem.runCommandAsync('execute as @s if entity @s [tag=canTP] run tag @e [type=ox:teleportentity,x=' + xco + ',y=' + yco + ',z=' + zco + ',r=1] add "῁des῟"');
                                    playertpitem.runCommandAsync("execute as @s if entity @s [tag=canTP] run scoreboard players add @e [type=ox:teleportentity,x=" + xco + ",y=" + yco + ",z=" + zco + ",r=1] TpDes῁ 0");
                                }
                                if (dropdown == 0) {
                                    playertpitem.runCommandAsync("execute as @s if entity @s [tag=canTP] run tag @e [type=ox:teleportentity,x=" + xco + ",y=" + yco + ",z=" + zco + ",r=1] add Private῁");
                                }
                                system.runTimeout(() => {
                                    playertpitem.runCommandAsync("execute at @s if entity @s [tag=canTP] run camera @s set example:example_free ease 0.5 in_out_back pos ~ ~1.5 ~ facing @e [type=ox:teleportentity,x=" + xco + ",y=" + yco + ",z=" + zco + ",r=1]");
                                    playertpitem.runCommandAsync("execute at @s if entity @s [tag=canTP] run tp @s ~ ~ ~ facing @e [type=ox:teleportentity,x=" + xco + ",y=" + yco + ",z=" + zco + ",r=1]");
                                    playertpitem.runCommandAsync("execute at @s if entity @s [tag=canTP] run particle ox:tppar " + xco + " " + yco + " " + zco + "");
                                    if (dropdown == 1) {
                                        playertpitem.runCommandAsync('execute at @s if entity @s [tag=canTP] run tellraw @a {"rawtext":[{"text":" §l§o§f"},{"selector":"@s"},{"text":"§r§l§d Has Created a New §5TELEPORTATION' + '\n' + '§bName : §3' + textfield + ' ' + '\n' + '§6Dimension : §f' + dimname + '"}]}');
                                        playertpitem.runCommandAsync('execute at @s if entity @s [tag=canTP] run playsound bubble.pop @a');
                                    } else if (dropdown == 0) {
                                        playertpitem.runCommandAsync('execute at @s if entity @s [tag=canTP] run tellraw @s {"rawtext":[{"text":" §l§o§fYou §r§l§dHave Created a New §5TELEPORTATION' + '\n' + '§bName : §3' + textfield + ' ' + '\n' + '§6Dimension : §f' + dimname + '"}]}');
                                        playertpitem.runCommandAsync('execute at @s if entity @s [tag=canTP] run playsound bubble.pop @s');
                                    }
                                    system.runTimeout(() => {
                                        playertpitem.runCommandAsync("execute at @s if entity @s [tag=canTP] run camera @s clear");
                                        playertpitem.runCommandAsync("execute as @s if entity @s [tag=canTP] run tag @s remove canTP");
                                    }, 10);
                                }, 35);
                            }
                        });
                    } else if (textfield == "" || textfield == " ") {
                        playertpitem.runCommandAsync('tellraw @s {"rawtext":[{"text":" §l§cYou Should Write a Name For The §5TELEPORTATION §C!"}]}');
                        playertpitem.runCommandAsync("playsound note.bass @s");
                        playertpitem.runCommandAsync("/setblock " + block.location.x + " " + block.location.y + " " + block.location.z + " air destroy");
                        playertpitem.runCommandAsync("/setblock " + block.location.x + " " + (block.location.y + 1) + " " + block.location.z + " air destroy");
                    } else if (textfieldname.length > 25) {
                        playertpitem.runCommandAsync('tellraw @s {"rawtext":[{"text":" §l§cThe Name is Too Long For The §5TELEPORTATION §C!"}]}');
                        playertpitem.runCommandAsync("playsound note.bass @s");
                        playertpitem.runCommandAsync("/setblock " + block.location.x + " " + block.location.y + " " + block.location.z + " air destroy");
                        playertpitem.runCommandAsync("/setblock " + block.location.x + " " + (block.location.y + 1) + " " + block.location.z + " air destroy");
                    }
                }
            });

        } else {
            playertpitem.runCommandAsync("/setblock " + block.location.x + " " + block.location.y + " " + block.location.z + " air destroy");
            playertpitem.runCommandAsync('/titleraw @s actionbar {"rawtext":[{"text":" §l§cYou Can Not Put The §dTeleportation §cHere !!"}]}');
            playertpitem.runCommandAsync("playsound note.bass @s");
        }
    }
});

///////////////////////////////////////////////


///////////////////////////////////////////////
world.beforeEvents.chatSend.subscribe((datam) => {
    const { message, sender } = datam;
    const tagp = sender.getTags();
    if (message == "tp/cr") {
        sender.runCommandAsync("/playsound random.orb @s");
        sender.runCommandAsync('tellraw @s {"rawtext":[{"text":" §l§aThis Addon Created By : §6oMZ3Go §r"}]}');
        datam.cancel = true;
        system.runTimeout(() => {
            sender.runCommandAsync('tellraw @s {"rawtext":[{"text":" §l§cYou§fTube : §r§fm_mz3g"}]}');
            sender.runCommandAsync("/playsound random.toast @s");
        }, 40);
        system.runTimeout(() => {
            sender.runCommandAsync('tellraw @s {"rawtext":[{"text":" §l§tDiscord : §r§fm_mz3g"}]}');
            sender.runCommandAsync("/playsound random.toast @s");
        }, 80);
    }
});

//////////////////////////////////////////////

world.beforeEvents.pistonActivate.subscribe((data) => {
    const attachedBlockLoc = data.piston.getAttachedBlocks();
    const dim = data.dimension;
    for (let attached of attachedBlockLoc) {
        if (dim.getBlock(attached).typeId.includes("ox:teleport")) {
            data.cancel = true;
        }
    }
});

const clicktp = world.afterEvents;

clicktp.itemStartUseOn.subscribe((dataontp) => {
    const playertp = dataontp.source;
    const blocktp = dataontp.block;
    let itemtp = "";
    if (dataontp.itemStack != undefined) {
        itemtp = dataontp.itemStack;
    } else {
        itemtp = "minecraft:hand";
    }

    if (blocktp.typeId === "ox:teleport" && itemtp.typeId != "ox:tp_fuel" && itemtp.typeId != "minecraft:dragon_breath" && itemtp.typeId != "ox:tppotion" || blocktp.typeId === "ox:teleport_top" && itemtp.typeId != "ox:tp_fuel" && itemtp.typeId != "minecraft:dragon_breath" && itemtp.typeId != "ox:tppotion") {
        const blocklocation = blocktp.location;

        const xco = Math.round(blocklocation.x);
        const yco = Math.round(blocklocation.y);
        const zco = Math.round(blocklocation.z);

        const dim = blocktp.dimension;

        let tpentity = "";
        if (blocktp.typeId === "ox:teleport") {
            tpentity = blocktp.dimension.getEntities({ location: blocktp.location, maxDistance: 0.8, type: 'ox:teleportentity' });
        } else {
            tpentity = blocktp.dimension.getEntities({ location: blocktp.location, maxDistance: 2, type: 'ox:teleportentity' });
        }

        let teleporten = "";
        if (!tpentity.length == 0) {
            for (let i = 0; i <= tpentity.length; i++) {
                if (tpentity[i].typeId == "ox:teleportentity") {
                    teleporten = "" + i;
                    break;
                }
            }
        }

        let reblocktop = "none";
        if (blocktp.typeId == "ox:teleport") {
            reblocktop = world.getDimension(blocktp.dimension.id).getBlock({ x: blocktp.location.x, y: blocktp.location.y + 1, z: blocktp.location.z });
        }

        let tptags = "";
        if (!teleporten == "") {
            tptags = tpentity[teleporten].getTags();
        } else if (teleporten == "" && reblocktop.typeId == "ox:teleport_top" || reblocktop == "none") {
            const blockloc = blocktp.location;
            let blockdim = "";
            if (blocktp.dimension.id == "minecraft:overworld") {
                blockdim = "overworld";
            } else if (blocktp.dimension.id == "minecraft:nether") {
                blockdim = "nether";
            } else if (blocktp.dimension.id == "minecraft:the_end") {
                blockdim = "the_end";
            }
            playertp.runCommandAsync('/execute positioned ' + blockloc.x + ' ' + blockloc.y + ' ' + blockloc.z + ' run tellraw @a [r=10] {"rawtext":[{"text":" §l§cThis §5TELEPORTATION §cHas Been Deleted , Because It Was Ruined !!"}]}');
            playertp.runCommandAsync("/execute positioned " + blockloc.x + " " + blockloc.y + " " + blockloc.z + " run playsound conduit.deactivate @a [r=10]");
            playertp.runCommandAsync("/execute in " + blockdim + " run particle minecraft:knockback_roar_particle " + blockloc.x + " " + blockloc.y + " " + blockloc.z + "");
            playertp.runCommandAsync("/execute in " + blockdim + " run setblock " + blockloc.x + " " + blockloc.y + " " + blockloc.z + " air destroy");
            if (blocktp.typeId === "ox:teleport") {
                playertp.runCommandAsync("/execute in " + blockdim + " run setblock " + blockloc.x + " " + (blockloc.y + 1) + " " + blockloc.z + " air destroy");
            } else {
                playertp.runCommandAsync("/execute in " + blockdim + " run setblock " + blockloc.x + " " + (blockloc.y - 1) + " " + blockloc.z + " air destroy");
            }
        }

        if (!tptags.includes("Teleporting῁") && !teleporten == "" && tptags.includes("Owner῁" + playertp.nameTag + "") || tptags.includes('CanUse῁' + playertp.nameTag + '') && !tptags.includes("Teleporting῁") || !tptags.includes("Private῁") && !tptags.includes("Teleporting῁")) {
            if (!teleporten == "") {
                playertp.runCommandAsync("/playsound block.end_portal_frame.fill @s");
                const formteleport = new ActionFormData();

                const tpentityTags = tpentity[teleporten].getTags();

                let objtp = world.scoreboard.getObjective("TpPlayer῁");
                objtp = objtp.getScore(tpentity[teleporten]);

                let objdes = world.scoreboard.getObjective("TpDes῁");
                objdes = objdes.getScore(tpentity[teleporten]);
                let tpTags = tpentity[teleporten].getTags().length;
                for (let i = 0; i <= tpTags; i++) {
                    if (!tpentityTags[i] == "") {
                        if (tpentityTags[i].startsWith("῟", 0)) {
                            let tpinfo = tpentityTags[i].split("῝");
                            let xs = Math.round(tpinfo[1]);
                            let ys = Math.round(tpinfo[2]);
                            let zs = Math.round(tpinfo[3]);

                            const tpdim = world.getDimension(tpinfo[4]);
                            const tpentityshow = tpdim.getEntities({
                                location: { x: xs, y: ys, z: zs },
                                maxDistance: 2,
                                type: "ox:teleportentity"
                            })[0]

                            if (tpentityshow?.nameTag == undefined) {
                                tpentity[teleporten].runCommandAsync("/scoreboard players remove @s TpPlayer῁ 1");
                                tpentity[teleporten].removeTag(tpentityTags[i]);
                                objtp = objtp - 1;
                            } else {
                                let dimsymbol = "";
                                let icon = "";
                                if (tpinfo[4] == "overworld") {
                                    dimsymbol = "";
                                    icon = "font/tpicon/overworldplanet";
                                } else if (tpinfo[4] == "nether") {
                                    dimsymbol = "";
                                    icon = "font/tpicon/netherplanet";
                                } else if (tpinfo[4] == "the_end") {
                                    dimsymbol = "";
                                    icon = "font/tpicon/endplanet";
                                }
                                formteleport.button("§r" + dimsymbol + " §l§f" + tpentityshow?.nameTag);
                                /*if (tpentityshow?.nameTag != tpinfo[1]) {
                                    tpentity[teleporten].removeTag(tpentityTags[i]);
                                    tpentity[teleporten].addTag("῟῝" + tpentityshow?.nameTag + "῝" + tpinfo[2] + "῝" + tpinfo[3] + "῝" + tpinfo[4] + "῝" + tpinfo[5] + "῝" + tpinfo[6]);

                                    let dimTpshow = "";
                                    if (tpentityshow?.dimension.id == "minecraft:overworld") {
                                        dimTpshow = "overworld";
                                    } else if (tpentityshow?.dimension.id == "minecraft:nether") {
                                        dimTpshow = "nether";
                                    } else if (tpentityshow?.dimension.id == "minecraft:the_end") {
                                        dimTpshow = "the_end";
                                    }

                                    const tpshowtag = tpentityadd?.getTags();
                                    const tpshowtagadmin = tpshowtag[0].split("῁");
                                    if (tpentity[teleporten].getTags().includes("῟῝" + tpentityshow?.nameTag + "῝" + tpentityshow?.location.x  + "῝" + tpentityshow?.location.y  + "῝" + tpentityshow?.location.z  + "῝" + dimTpshow + "῝" + tpshowtagadmin[1])){
                                        tpentity[teleporten].removeTag(tpentityTags[i]);
                                    }
                                }*/
                            }
                        }
                    }
                }

                let des = "";
                if (objdes == 1) {
                    for (let i = 0; i <= tpTags; i++) {
                        if (!tpentityTags[i] == "") {
                            if (tpentityTags[i].startsWith("῁des", 0)) {
                                des = tpentityTags[i].split("῟");
                                formteleport.body("\n" + des[1] + "\n" + "\n" + "                §r §l§ePower : §f" + (tpentity[teleporten].getComponent("minecraft:health").currentValue - 1) + "" + "\n" + "\n" + "         §l§fChoose What You Want");
                            }
                        }
                    }
                } else {
                    formteleport.body("\n" + "     " + "\n" + "\n" + "                §r §l§ePower : §f" + (tpentity[teleporten].getComponent("minecraft:health").currentValue - 1) + "" + "\n" + "\n" + "         §l§fChoose What You Want");
                }

                formteleport.title(" §l§5" + tpentity[teleporten].nameTag);

                formteleport.button(" §l§5Link/add");
                formteleport.button(" §l§pDetails  ");
                if (tpentity[teleporten].getTags().includes("Owner῁" + playertp.nameTag + "")) {
                    formteleport.button(" §l§tSettings");
                }


                formteleport.show(playertp).then((result) => {
                    if (result.canceled) {
                        playertp.runCommandAsync("/playsound block.false_permissions @s");
                    } else if (result.selection == objtp) {

                        playertp.runCommandAsync("playsound random.pop2 @s");
                        const addtpForm = new ModalFormData();

                        addtpForm.title(" §l§5" + tpentity[teleporten].nameTag);
                        addtpForm.textField("\n" + "\n" + "           §l§dAdding/Linking §fPage" + "\n" + "\n" + "\n" + "§l§fCoordinates :", "Write Here - e.g : 45 68 30");

                        let worldtype = [" §l§2OVERWORLD", " §l§4NETHER", " §l§eTHE END"]
                        if (playertp.dimension.id == "minecraft:overworld") {
                            addtpForm.dropdown("§l§fChoose The §dDimension :", worldtype, 0);
                        } else if (playertp.dimension.id == "minecraft:nether") {
                            addtpForm.dropdown("§l§fChoose The §dDimension :", worldtype, 1);
                        } else if (playertp.dimension.id == "minecraft:the_end") {
                            addtpForm.dropdown("§l§fChoose The §dDimension :", worldtype, 2);
                        }

                        addtpForm.show(playertp).then((addresult) => {
                            if (addresult.canceled) {
                                playertp.runCommandAsync("/playsound block.false_permissions @s");
                            } else {
                                let [textfield, dropdowndim] = addresult.formValues;
                                if (textfield != "") {
                                    let dim = "";
                                    let dimname = "";
                                    if (dropdowndim == 0) {
                                        dim = "overworld";
                                        dimname = " §l§2OVERWORLD";
                                    } else if (dropdowndim == 1) {
                                        dim = "nether";
                                        dimname = " §l§4NETHER";
                                    } else if (dropdowndim == 2) {
                                        dim = "the_end";
                                        dimname = " §l§eTHE END";
                                    }

                                    let coordinates = textfield.split(" ");
                                    let xco = Math.round(coordinates[0]);
                                    let yco = Math.round(coordinates[1]);
                                    let zco = Math.round(coordinates[2]);

                                    if (dropdowndim == 0 && yco <= 317 && yco >= -63 || dropdowndim == 1 && yco <= 124 && yco >= 1 || dropdowndim == 2 && yco <= 253 && yco >= 1) {
                                        playertp.runCommandAsync('/execute in ' + dim + ' run tickingarea add circle ' + xco + ' ' + yco + ' ' + zco + ' 3 "Teleport' + playertp.nameTag + '" true');
                                        playertp.runCommandAsync('/execute in ' + dim + ' run tickingarea preload ' + xco + ' ' + yco + ' ' + zco + ' true');

                                        system.runTimeout(() => {
                                            let onblock = world.getDimension(dim).getBlock({ x: xco, y: yco, z: zco });
                                            let topblock = world.getDimension(dim).getBlock({ x: xco, y: yco + 1, z: zco });

                                            const overworld = world.getDimension(dim);
                                            const tpentityadd = overworld.getEntities({
                                                location: { x: xco, y: yco, z: zco },
                                                maxDistance: 21,
                                                type: "ox:teleportentity"
                                            })[0]
                                            if (tpentityadd?.id != tpentity[teleporten].id) {
                                                if (tpentityadd?.nameTag == undefined) {
                                                    if (topblock != undefined && onblock != undefined) {
                                                        if (topblock.isAir && onblock.isAir) {
                                                            playertp.runCommandAsync("playsound random.pop2 @s");
                                                            const formsure = new MessageFormData();

                                                            formsure.title(" §l§eNote :");

                                                            formsure.body("§l§fThere isn't any §dTeleportation " + "\n" + "§fin §e" + dimname + "\n" + "§fat §6" + xco + " " + yco + " " + zco + "\n" + "\n" + "§l§fDo You Want To set The New §dTeleportation's §5Partner" + "\n" + "§fin " + dimname + "\n" + "§fat §6" + xco + " " + yco + " " + zco + "");
                                                            formsure.button2("");
                                                            formsure.button1("");

                                                            formsure.show(playertp).then((sureresult) => {
                                                                if (sureresult.canceled) {
                                                                    playertp.runCommandAsync('/execute in ' + dim + ' run tickingarea remove "Teleport' + playertp.nameTag + '"');
                                                                    playertp.runCommandAsync("/playsound block.false_permissions @s");
                                                                } else if (sureresult.selection == 0) {
                                                                    playertp.runCommandAsync('/execute in ' + dim + ' run tickingarea remove "Teleport' + playertp.nameTag + '"');
                                                                    playertp.runCommandAsync("/playsound block.false_permissions @s");
                                                                } else if (sureresult.selection == 1) {

                                                                    let inventory = playertp.getComponent("minecraft:inventory").container;
                                                                    let selectcoin = "ox:teleport";
                                                                    let amount = 0;
                                                                    for (let i = 0; i < inventory.size; i++) {
                                                                        const item = inventory.getItem(i);
                                                                        if (!item || item.typeId != selectcoin) continue;
                                                                        amount += item.amount;
                                                                    }

                                                                    if (amount >= 1) {
                                                                        playertp.runCommandAsync("clear @s ox:teleport -1 1");

                                                                        playertp.runCommandAsync("execute in " + dim + " run tp @s " + xco + " " + (yco + 0.5) + " " + zco + " 0 0");
                                                                        playertp.runCommandAsync("execute in " + dim + " run camera @s set example:example_free ease 0.7 in_out_back pos " + xco + " " + (yco + 5) + " " + zco + " rot 90 0");
                                                                        playertp.runCommandAsync("execute in " + dim + " run /playanimation @s animation.react_bottom_3");
                                                                        playertp.runCommandAsync("execute in " + dim + " run playsound respawn_anchor.charge @a [r=10]");
                                                                        playertp.runCommandAsync("execute in " + dim + " run particle minecraft:knockback_roar_particle " + xco + " " + (yco + 1) + " " + zco + "");
                                                                        playertp.runCommandAsync("execute in " + dim + " run setblock " + xco + " " + yco + " " + zco + " ox:teleport");
                                                                        playertp.runCommandAsync("execute in " + dim + " run setblock " + xco + " " + (yco + 1) + " " + zco + " ox:teleport_top");
                                                                        playertp.runCommandAsync('execute in ' + dim + ' run summon ox:teleportentity ' + xco + ' ' + (yco + 0.1) + ' ' + zco + ' 0 0 ');


                                                                        playertp.runCommandAsync('execute in ' + dim + ' run tag @e [type=ox:teleportentity,x=' + xco + ',y=' + yco + ',z=' + zco + ',r=1] add "Owner῁' + playertp.nameTag + '"');
                                                                        let entitycoor = tpentity[teleporten].location;
                                                                        let entitydim = "";
                                                                        if (tpentity[teleporten].dimension.id == "minecraft:overworld") {
                                                                            entitydim = "overworld";
                                                                        } else if (tpentity[teleporten].dimension.id == "minecraft:nether") {
                                                                            entitydim = "nether";
                                                                        } else if (tpentity[teleporten].dimension.id == "minecraft:the_end") {
                                                                            entitydim = "the_end";
                                                                        }
                                                                        playertp.runCommandAsync('execute in ' + dim + ' run tag @e [type=ox:teleportentity,x=' + xco + ',y=' + yco + ',z=' + zco + ',r=1] add "῟῝' + entitycoor.x + '῝' + entitycoor.y + '῝' + entitycoor.z + '῝' + entitydim + '῝' + playertp.nameTag + '"');
                                                                        playertp.runCommandAsync("execute in " + dim + " run scoreboard players add @e [type=ox:teleportentity,x=" + xco + ",y=" + yco + ",z=" + zco + ",r=1] TpPlayer῁ 1");
                                                                        //
                                                                        playertp.runCommandAsync('execute in ' + dim + ' run tag @e [type=ox:teleportentity,x=' + xco + ',y=' + yco + ',z=' + zco + ',r=1] add "῁des῟"');
                                                                        playertp.runCommandAsync("execute in " + dim + " run scoreboard players add @e [type=ox:teleportentity,x=" + xco + ",y=" + yco + ",z=" + zco + ",r=1] TpDes῁ 0");
                                                                        system.runTimeout(() => {
                                                                            const tpentityadde = overworld.getEntities({
                                                                                location: { x: xco, y: yco, z: zco },
                                                                                maxDistance: 3,
                                                                                type: "ox:teleportentity"
                                                                            })[0]

                                                                            playertp.runCommandAsync("execute in " + dim + " run camera @s set example:example_free ease 0.5 in_out_back pos ~ ~1.5 ~ facing @e [type=ox:teleportentity,x=" + xco + ",y=" + yco + ",z=" + zco + ",r=1]");
                                                                            playertp.runCommandAsync("execute in " + dim + " run particle ox:tppar " + xco + " " + yco + " " + zco + "");
                                                                            playertp.runCommandAsync('execute in ' + dim + ' run tellraw @s {"rawtext":[{"text":" §l§o§fYou §r§l§dHave Created a New §5TELEPORTATION' + '\n' + '§bName : §3' + tpentity[teleporten].nameTag + " Partner" + ' ' + '\n' + '§6Dimension : §f' + dimname + '"}]}');
                                                                            playertp.runCommandAsync('execute in ' + dim + ' run playsound bubble.pop @s')
                                                                            system.runTimeout(() => {
                                                                                tpentity[teleporten].addTag("῟῝" + tpentityadde?.location.x + "῝" + tpentityadde?.location.y + "῝" + tpentityadde?.location.z + "῝" + dim + "῝" + playertp.nameTag);
                                                                                tpentity[teleporten].runCommandAsync("/scoreboard players add @s TpPlayer῁ 1");

                                                                                let tpentitye = world.getDimension(dim).getEntities({ location: { x: xco, y: yco, z: zco }, maxDistance: 0.8, type: 'ox:teleportentity' });
                                                                                tpentitye[0].getComponent("minecraft:health").setCurrentValue(401);
                                                                                tpentitye[0].nameTag = tpentity[teleporten].nameTag + " Partner";

                                                                                playertp.runCommandAsync("execute in " + dim + " run camera @s clear");
                                                                                playertp.runCommandAsync('/execute in ' + dim + ' run tickingarea remove "Teleport' + playertp.nameTag + '"');
                                                                            }, 10);
                                                                        }, 35);
                                                                    } else {

                                                                        playertp.runCommand('tellraw @s {"rawtext":[{"text":" §l§cYou Do Not Have a §dTeleportation §c!"}]}');
                                                                        playertp.runCommand("playsound note.bass @s");
                                                                    }
                                                                }
                                                            });

                                                        } else {
                                                            playertp.runCommandAsync('/execute in ' + dim + ' run tickingarea remove "Teleport' + playertp.nameTag + '"');
                                                            playertp.runCommand('tellraw @s {"rawtext":[{"text":" §l§cThere are Blocks in The §5Coordinates §c!"}]}');
                                                            playertp.runCommand("playsound note.bass @s");
                                                        }
                                                    } else {
                                                        playertp.runCommandAsync('/execute in ' + dim + ' run tickingarea remove "Teleport' + playertp.nameTag + '"');
                                                        playertp.runCommand('tellraw @s {"rawtext":[{"text":" §l§cThe §dCoordinates §care Too Far !"}]}');
                                                        playertp.runCommand("playsound note.bass @s");
                                                    }
                                                } else {
                                                    const tpaddtag = tpentityadd?.getTags();
                                                    const tpaddtagadmin = tpaddtag[0].split("῁");
                                                    const tpmaintag = tpentity[teleporten].getTags();
                                                    const tpmaintagadmin = tpmaintag[0].split("῁");

                                                    let entitydim = "";
                                                    if (tpentity[teleporten].dimension.id == "minecraft:overworld") {
                                                        entitydim = "overworld";
                                                    } else if (tpentity[teleporten].dimension.id == "minecraft:nether") {
                                                        entitydim = "nether";
                                                    } else if (tpentity[teleporten].dimension.id == "minecraft:the_end") {
                                                        entitydim = "the_end";
                                                    }

                                                    if (!tpentity[teleporten].getTags().includes("῟῝" + tpentity[teleporten].location.x + "῝" + tpentityadd?.location.y + "῝" + tpentityadd?.location.z + "῝" + dim + "῝" + tpaddtagadmin[1]) && !tpentityadd?.getTags().includes("῟῝" + tpentity[teleporten].nameTag + "῝" + tpentity[teleporten].location.x + "῝" + tpentity[teleporten].location.y + "῝" + tpentity[teleporten].location.z + "῝" + entitydim + "῝" + tpmaintagadmin[1])) {

                                                        playertp.runCommandAsync("playsound random.pop2 @s");
                                                        const formsure = new MessageFormData();

                                                        formsure.title(" §l§eNote :");

                                                        formsure.body("§l§fThere is §d" + tpentityadd?.nameTag + " " + "\n" + "§fin §e" + dimname + "\n" + "§fat §6" + xco + " " + yco + " " + zco + "\n" + "\n" + "§fDo You Want To Link it With This §dTeleportation");
                                                        formsure.button2("");
                                                        formsure.button1("");

                                                        formsure.show(playertp).then((sureresult) => {
                                                            if (sureresult.canceled) {
                                                                playertp.runCommandAsync('/execute in ' + dim + ' run tickingarea remove "Teleport' + playertp.nameTag + '"');
                                                                playertp.runCommandAsync("/playsound block.false_permissions @s");
                                                            } else if (sureresult.selection == 0) {
                                                                playertp.runCommandAsync('/execute in ' + dim + ' run tickingarea remove "Teleport' + playertp.nameTag + '"');
                                                                playertp.runCommandAsync("/playsound block.false_permissions @s");
                                                            } else if (sureresult.selection == 1) {

                                                                if (!tpentityadd?.getTags().includes("Private῁") || tpentityadd?.getTags().includes("Owner῁" + playertp.nameTag + "") || tpentityadd?.getTags().includes("CanUse῁" + playertp.nameTag)) {

                                                                    tpentity[teleporten].addTag("῟῝" + tpentityadd?.location.x + "῝" + tpentityadd?.location.y + "῝" + tpentityadd?.location.z + "῝" + dim + "῝" + tpaddtagadmin[1]);
                                                                    tpentity[teleporten].runCommandAsync("/scoreboard players add @s TpPlayer῁ 1");
                                                                    tpentityadd?.addTag("῟῝" + tpentity[teleporten].location.x + "῝" + tpentity[teleporten].location.y + "῝" + tpentity[teleporten].location.z + "῝" + entitydim + "῝" + tpmaintagadmin[1]);
                                                                    tpentityadd?.runCommandAsync("/scoreboard players add @s TpPlayer῁ 1");

                                                                    playertp.runCommand('tellraw @s {"rawtext":[{"text":" §l§fThe §f' + tpentityadd?.nameTag + ' §dHas Linked With §f' + tpentity[teleporten].nameTag + ' §dSuccessfully"}]}');
                                                                    playertp.runCommand("/playsound random.toast @s");
                                                                    tpentity[teleporten].runCommandAsync("particle minecraft:knockback_roar_particle ~ ~0.5 ~");
                                                                    tpentityadd?.runCommandAsync("particle minecraft:knockback_roar_particle ~ ~0.5 ~");
                                                                } else {
                                                                    if (tpentityadd?.getTags().includes("Private῁")) {
                                                                        playertp.runCommand('tellraw @s {"rawtext":[{"text":" §l§cThe §d' + tpentityadd?.nameTag + ' §cis §fPrivate §c!!"}]}');
                                                                        playertp.runCommand("playsound note.bass @s");
                                                                    }
                                                                }
                                                                playertp.runCommandAsync('/execute in ' + dim + ' run tickingarea remove "Teleport' + playertp.nameTag + '"');
                                                            }

                                                        });
                                                    } else if (tpentity[teleporten].getTags().includes("῟῝" + tpentityadd?.location.x + "῝" + tpentityadd?.location.y + "῝" + tpentityadd?.location.z + "῝" + dim + "῝" + tpaddtagadmin[1])) {
                                                        playertp.runCommand('tellraw @s {"rawtext":[{"text":" §l§cThe §d' + tpentityadd?.nameTag + ' §cis Already Exist §c!!"}]}');
                                                        playertp.runCommand("playsound note.bass @s");
                                                    }
                                                }
                                            } else {
                                                playertp.runCommandAsync('/execute in ' + dim + ' run tickingarea remove "Teleport' + playertp.nameTag + '"');
                                                playertp.runCommand('tellraw @s {"rawtext":[{"text":" §l§cYou Can Not Link The §dTeleportation §cWith Itself!"}]}');
                                                playertp.runCommand("playsound note.bass @s");
                                            }
                                        }, 20);
                                    } else {
                                        playertp.runCommandAsync('/execute in ' + dim + ' run tickingarea remove "Teleport' + playertp.nameTag + '"');
                                        playertp.runCommand('tellraw @s {"rawtext":[{"text":" §l§cThe §dCoordinates §care Invalid !"}]}');
                                        playertp.runCommand("playsound note.bass @s");
                                    }
                                } else {
                                    playertp.runCommandAsync("/playsound block.false_permissions @s");
                                }

                            }

                        });
                    } else if (result.selection == objtp + 1) {
                        playertp.runCommandAsync("playsound random.pop2 @s");
                        const detailpage = new ModalFormData();

                        detailpage.title(" §5§l" + tpentity[teleporten].nameTag);
                        let tagslength = tpentity[teleporten].getTags().length;

                        let tplink = ["§l§fNone"];
                        let tplinktag = ["None"];
                        for (let i = 0; i <= tagslength; i++) {
                            if (!tpentityTags[i] == "") {
                                if (tpentityTags[i].startsWith("῟", 0)) {
                                    tplinktag.push(tpentityTags[i]);
                                    let tplinkpart = tpentityTags[i].split("῝");
                                    let dimsymbol = "";
                                    if (tplinkpart[4] == "overworld") {
                                        dimsymbol = "";
                                    } else if (tplinkpart[4] == "nether") {
                                        dimsymbol = "";
                                    } else if (tplinkpart[4] == "the_end") {
                                        dimsymbol = "";
                                    }
                                    let xco = Math.round(tplinkpart[1]);
                                    let yco = Math.round(tplinkpart[2]);
                                    let zco = Math.round(tplinkpart[3]);

                                    const tpdim = world.getDimension(tplinkpart[4]);

                                    const tpentityde = tpdim.getEntities({
                                        location: { x: xco, y: yco, z: zco },
                                        maxDistance: 21,
                                        type: "ox:teleportentity"
                                    })[0]
                                    tplink.push(dimsymbol + " §l§f" + tpentityde?.nameTag);
                                }
                            }
                        }
                        detailpage.dropdown("\n" + "\n" + "                 §l§pDetails §fPage" + "\n" + "\n" + "\n" + " §l§pShow Details§f About :" + "\n" + " ", tplink);

                        detailpage.show(playertp).then((detailrespone) => {
                            if (detailrespone.canceled) {
                                playertp.runCommandAsync("/playsound block.false_permissions @s");
                            } else {
                                let [dropdownde] = detailrespone.formValues;
                                if (dropdownde != 0) {
                                    let tpdetails = tplinktag[dropdownde].split("῝");

                                    const xco = Math.trunc(tpdetails[1]);
                                    const yco = Math.trunc(tpdetails[2]);
                                    const zco = Math.trunc(tpdetails[3]);

                                    let dimname = "";
                                    if (tpdetails[4] == "overworld") {
                                        dimname = " §l§aOVERWORLD";
                                    } else if (tpdetails[4] == "nether") {
                                        dimname = " §l§cNETHER";
                                    } else if (tpdetails[4] == "the_end") {
                                        dimname = " §l§eTHE END";
                                    }

                                    let blocksAway = Math.sqrt(Math.pow(xco - tpentity[teleporten].location.x, 2) + Math.pow(yco - tpentity[teleporten].location.y, 2) + Math.pow(zco - tpentity[teleporten].location.z, 2));

                                    playertp.runCommandAsync("/playsound random.toast @s");

                                    const tpdim = world.getDimension(tpdetails[4]);
                                    const tpentityde = tpdim.getEntities({
                                        location: { x: xco, y: yco, z: zco },
                                        maxDistance: 21,
                                        type: "ox:teleportentity"
                                    })[0]
                                    playertp.runCommandAsync('tellraw @s {"rawtext":[{"text":" §l§dDetails §fAbout §5' + tpentityde?.nameTag + ' :' + '\n' + '§l§sOwner : §b' + tpdetails[5] + ' ' + '\n' + '§l§6Dimension : ' + dimname + ' ' + '\n' + '§l§2Coordinates :§a ' + xco + ' ' + yco + ' ' + zco + ' ' + '\n' + '§7(' + Math.round(blocksAway) + ' Blocks Away) "}]}');

                                } else {
                                    playertp.runCommandAsync("/playsound block.false_permissions @s");
                                }
                            }
                        });

                    } else if (result.selection == objtp + 2) {
                        playertp.runCommandAsync("playsound random.pop2 @s");

                        const settingpage = new ModalFormData();
                        let tagslength = tpentity[teleporten].getTags().length;

                        settingpage.title(" §5§l" + tpentity[teleporten].nameTag);

                        settingpage.textField("\n" + "\n" + "                §l§3Settings §fPage" + "\n" + "\n" + "\n" + " §l§fDescription :" + "\n" + " ", "Write Here ...", des[1]);
                        settingpage.textField("" + "\n" + " §l§fName Tag :" + "\n" + " ", "Write Here ...", tpentity[teleporten].nameTag);

                        if (tpentity[teleporten].getTags().includes("Private῁")) {
                            settingpage.dropdown("\n" + " §l§dPrivacy §fMode :" + "\n" + " ", [" §l§fPrivate", " §l§fPublic"], 0);
                        } else if (!tpentity[teleporten].getTags().includes("Private῁")) {
                            settingpage.dropdown("\n" + " §l§dPrivacy §fMode :" + "\n" + " ", [" §l§fPrivate", " §l§fPublic"], 1);
                        }


                        let tplink = ["§l§fNone"];
                        let tplinktag = ["None"];
                        let allowdplr = ["§l§fNone"];
                        for (let i = 0; i <= tagslength; i++) {
                            if (!tpentityTags[i] == "") {
                                if (tpentityTags[i].startsWith("῟", 0)) {
                                    tplinktag.push(tpentityTags[i]);
                                    let tplinkpart = tpentityTags[i].split("῝");
                                    let dimsymbol = "";
                                    if (tplinkpart[4] == "overworld") {
                                        dimsymbol = "";
                                    } else if (tplinkpart[4] == "nether") {
                                        dimsymbol = "";
                                    } else if (tplinkpart[4] == "the_end") {
                                        dimsymbol = "";
                                    }

                                    let xco = Math.round(tplinkpart[1]);
                                    let yco = Math.round(tplinkpart[2]);
                                    let zco = Math.round(tplinkpart[3]);

                                    const tpdim = world.getDimension(tplinkpart[4]);
                                    const tpentityse = tpdim.getEntities({
                                        location: { x: xco, y: yco, z: zco },
                                        maxDistance: 21,
                                        type: "ox:teleportentity"
                                    })[0]
                                    tplink.push(dimsymbol + " §l§f" + tpentityse?.nameTag);
                                }
                            }
                        }

                        let allplayers = world.getAllPlayers().filter(plr => playertp.name !== plr.name).map(playertp => playertp.name);
                        allplayers.unshift("§l§fNone");

                        for (let i = 0; i <= tagslength; i++) {
                            if (!tpentityTags[i] == "") {
                                if (tpentityTags[i].startsWith('CanUse῁', 0)) {
                                    let allowdplrpart = tpentityTags[i].split("῁");
                                    allowdplr.push("" + allowdplrpart[1]);
                                    if (tpentity[teleporten].getTags().includes('CanUse῁' + allowdplrpart[1])) {
                                        allplayers = allplayers.filter(plr => plr !== allowdplrpart[1]);
                                    }
                                }
                            }
                        }

                        settingpage.dropdown("\n" + " §l§cRemove §fa Teleportation :" + "\n" + " ", tplink);

                        settingpage.dropdown("\n" + " §l§aAdd §fa Player :" + "\n" + " ", allplayers);
                        settingpage.dropdown("\n" + " §l§cRemove §fa Player :" + "\n" + " ", allowdplr);

                        settingpage.dropdown("\n" + " §l§cDestroy §f" + tpentity[teleporten].nameTag + " :" + "\n" + " ", ["", ""], 1);
                        settingpage.show(playertp).then((settresult) => {
                            if (settresult.canceled) {
                                playertp.runCommandAsync("/playsound block.false_permissions @s");
                            } else {
                                let [textboxDec, textboxName, dropdownP, dropdownRtp, dropdownAplr, dropdownRplr, dropdownRmain] = settresult.formValues;

                                let messageTxt = "";
                                let textname = "" + textboxName;

                                if (dropdownRmain == 0) {
                                    messageTxt = messageTxt + "\n" + "\n" + " §l§cDestroy §f" + tpentity[teleporten].nameTag + " :" + "\n" + "\n" + "§r§l§eAre You Sure About Destroying §f" + tpentity[teleporten].nameTag;
                                }

                                if (tpentity[teleporten].nameTag != textboxName && textname.length <= 25) {
                                    messageTxt = messageTxt + "\n" + "\n" + " §oName Tag :" + "\n" + "\n" + "§r§l§c" + tpentity[teleporten].nameTag + " §f-> §a" + textboxName + "";
                                } else if (textname.length > 25) {
                                    messageTxt = messageTxt + "\n" + "\n" + " §oName Tag :" + "\n" + "\n" + "§r§l§c The Name is Too Long !!";
                                }

                                if (des[1] != textboxDec && des[1] != undefined) {
                                    messageTxt = messageTxt + "\n" + "\n" + " §o§fDescription :" + "\n" + "\n" + "§r§l§c" + des[1] + " §f-> §a" + textboxDec + "";
                                } else if (des[1] == undefined && textboxDec != "") {
                                    messageTxt = messageTxt + "\n" + "\n" + " §o§fDescription :" + "\n" + "\n" + "§r§l§c" + "§a" + textboxDec + "";
                                }

                                if (dropdownP == 1 && tpentity[teleporten].getTags().includes("Private῁")) {
                                    messageTxt = messageTxt + "\n" + "\n" + " §l§f§oPrivacy :§r" + "\n" + "\n" + "§l§fSet To §dPublic" + "";
                                } else if (dropdownP == 0 && !tpentity[teleporten].getTags().includes("Private῁")) {
                                    messageTxt = messageTxt + "\n" + "\n" + " §l§f§oPrivacy :§r" + "\n" + "\n" + "§l§fSet To §dPrivate" + "";
                                }

                                if (dropdownRtp != 0) {
                                    messageTxt = messageTxt + "\n" + "\n" + " §l§c§oRemove §fa Teleportation :§r§c" + "\n" + "\n" + tplink[dropdownRtp] + "";
                                }

                                if (dropdownAplr != 0 && !tpentity[teleporten].getTags().includes('CanUse῁' + allplayers[dropdownAplr] + '')) {
                                    messageTxt = messageTxt + "\n" + "\n" + " §l§o§aAdd §fa Player :§r§a" + "\n" + "\n" + allplayers[dropdownAplr] + "";
                                }

                                if (dropdownRplr != 0) {
                                    messageTxt = messageTxt + "\n" + "\n" + " §l§o§cRemove §fa Player :§r§c" + "\n" + "\n" + allowdplr[dropdownRplr];
                                }

                                if (messageTxt != "") {
                                    playertp.runCommandAsync("playsound random.pop2 @s");
                                    const suresett = new MessageFormData();

                                    suresett.title(" §e§lNote : §4Are You Sure ??");
                                    suresett.body("§f§lDo You Want To Continue With The Following Changes ?" + messageTxt);

                                    suresett.button2("");
                                    suresett.button1("");

                                    suresett.show(playertp).then((surerespone) => {
                                        if (surerespone.canceled) {
                                            playertp.runCommandAsync("/playsound block.false_permissions @s");
                                        } else if (surerespone.selection == 0) {
                                            playertp.runCommandAsync("/playsound block.false_permissions @s");
                                        } else if (surerespone.selection == 1) {
                                            if (dropdownRmain != 0) {
                                                tpentity[teleporten].runCommandAsync("/particle minecraft:endrod ~ ~1 ~");
                                                playertp.runCommandAsync("/playsound random.toast @s");
                                                playertp.runCommandAsync('tellraw @s {"rawtext":[{"text":" §l§aThe Changes Have Applied Successfully"}]}');

                                                if (des[1] != textboxDec) {
                                                    let desNum = 0;
                                                    for (let i = 0; i <= objdes + 1; i++) {
                                                        if (!tpentityTags[i] == "") {
                                                            if (tpentityTags[i].startsWith("῁des", 0)) {
                                                                desNum = 1;
                                                                tpentity[teleporten].runCommandAsync('tag @s remove "' + tpentityTags[i] + '"');
                                                                tpentity[teleporten].runCommandAsync('/scoreboard players set @s "TpDes῁" 0');
                                                                if (textboxDec != "") {
                                                                    tpentity[teleporten].runCommandAsync('tag @s add "῁des῟' + textboxDec + '"');
                                                                    tpentity[teleporten].runCommandAsync('/scoreboard players set @s "TpDes῁" 1');
                                                                } else {
                                                                    tpentity[teleporten].runCommandAsync('tag @s add "῁des῟"');
                                                                    tpentity[teleporten].runCommandAsync('/scoreboard players set @s "TpDes῁" 0');
                                                                }
                                                            }
                                                        }
                                                    }

                                                    if (desNum == 0) {
                                                        tpentity[teleporten].runCommandAsync('tag @s add "῁des῟"');
                                                        tpentity[teleporten].runCommandAsync('/scoreboard players set @s "TpDes῁" 0');
                                                    }
                                                }

                                                if (dropdownRtp != 0) {
                                                    let tpinfo = tplinktag[dropdownRtp].split("῝");
                                                    let xs = Math.round(tpinfo[1]);
                                                    let ys = Math.round(tpinfo[2]);
                                                    let zs = Math.round(tpinfo[3]);
                                                    const tpdim = world.getDimension(tpinfo[4]);
                                                    const tpentityremove = tpdim.getEntities({
                                                        location: { x: xs, y: ys, z: zs },
                                                        maxDistance: 2,
                                                        type: "ox:teleportentity"
                                                    })[0]

                                                    let tpendim = "";
                                                    if (tpentity[teleporten].dimension.id == "minecraft:overworld") {
                                                        tpendim = "overworld";
                                                    } else if (tpentity[teleporten].dimension.id == "minecraft:nether") {
                                                        tpendim = "nether";
                                                    } if (tpentity[teleporten].dimension.id == "minecraft:the_end") {
                                                        tpendim = "the_end";
                                                    }
                                                    tpentityremove?.removeTag("῟῝" + tpentity[teleporten].location.x + "῝" + tpentity[teleporten].location.y + "῝" + tpentity[teleporten].location.z + "῝" + tpendim + "῝" + playertp.nameTag);
                                                    tpentityremove?.runCommandAsync('scoreboard players remove @s "TpPlayer῁" 1');

                                                    tpentity[teleporten].removeTag(tplinktag[dropdownRtp]);
                                                    tpentity[teleporten].runCommandAsync('scoreboard players remove @s "TpPlayer῁" 1');
                                                }

                                                if (tpentity[teleporten].nameTag != textboxName && textname.length <= 25) {
                                                    tpentity[teleporten].nameTag = "" + textboxName;
                                                }

                                                if (dropdownP == 0 && !tpentity[teleporten].getTags().includes("Private῁")) {
                                                    tpentity[teleporten].addTag("Private῁");
                                                } else if (dropdownP == 1 && tpentity[teleporten].getTags().includes("Private῁")) {
                                                    tpentity[teleporten].removeTag("Private῁");
                                                }


                                                if (dropdownRplr != 0) {
                                                    tpentity[teleporten].removeTag('CanUse῁' + allowdplr[dropdownRplr] + '');
                                                }

                                                if (dropdownAplr != 0 && !tpentity[teleporten].getTags().includes('CanUse῁' + allplayers[dropdownAplr] + '')) {
                                                    tpentity[teleporten].addTag('CanUse῁' + allplayers[dropdownRplr + 1] + '');
                                                }
                                            } else if (dropdownRmain == 0) {
                                                let tpTags = tpentity[teleporten].getTags().length;
                                                for (let i = 0; i <= tpTags; i++) {
                                                    if (!tpentityTags[i] == "") {
                                                        if (tpentityTags[i].startsWith("῟", 0)) {
                                                            let tpinfo = tpentityTags[i].split("῝");
                                                            let xs = Math.round(tpinfo[1]);
                                                            let ys = Math.round(tpinfo[2]);
                                                            let zs = Math.round(tpinfo[3]);
                                                            const tpdim = world.getDimension(tpinfo[4]);
                                                            const tpentityshow = tpdim.getEntities({
                                                                location: { x: xs, y: ys, z: zs },
                                                                maxDistance: 2,
                                                                type: "ox:teleportentity"
                                                            })[0]

                                                            let entitydim = "";
                                                            if (tpentity[teleporten].dimension.id == "minecraft:overworld") {
                                                                entitydim = "overworld";
                                                            } else if (tpentity[teleporten].dimension.id == "minecraft:nether") {
                                                                entitydim = "nether";
                                                            } else if (tpentity[teleporten].dimension.id == "minecraft:the_end") {
                                                                entitydim = "the_end";
                                                            }

                                                            tpentityshow?.runCommandAsync('/scoreboard players remove @s "TpPlayer῁" 1');
                                                            tpentityshow?.removeTag("῟῝" + tpentity[teleporten].location.x + "῝" + tpentity[teleporten].location.y + "῝" + tpentity[teleporten].location.z + "῝" + entitydim + "῝" + playertp.nameTag);
                                                            //world.getDimension(tpentity[teleporten].dimension.id).spawnItem("ox:tp_item", tpentity[teleporten].location);
                                                        }
                                                    }
                                                }

                                                playertp.runCommandAsync("/setblock " + blocktp.location.x + " " + blocktp.location.y + " " + blocktp.location.z + " air destroy");
                                                playertp.runCommandAsync("particle minecraft:egg_destroy_emitter " + blocktp.location.x + " " + (blocktp.location.y + 1) + " " + blocktp.location.z + "");
                                                playertp.runCommandAsync("/playsound respawn_anchor.deplete @a [x=" + blocktp.location.x + ",y=" + (blocktp.location.y + 1) + ",z=" + blocktp.location.z + ",r=8]");
                                                playertp.runCommandAsync('tellraw @a [x=' + blocktp.location.x + ',y=' + (blocktp.location.y + 1) + ',z=' + blocktp.location.z + ',r=8] {"rawtext":[{"text":" §l§f' + tpentity[teleporten].nameTag + ' §dHas Destroyed Successfully"}]}');
                                                if (blocktp.typeId == "ox:teleport") {
                                                    playertp.runCommandAsync("/setblock " + blocktp.location.x + " " + (blocktp.location.y + 1) + " " + blocktp.location.z + " air destroy");
                                                } else if (blocktp.typeId == "ox:teleport_top") {
                                                    playertp.runCommandAsync("/setblock " + blocktp.location.x + " " + (blocktp.location.y - 1) + " " + blocktp.location.z + " air destroy");
                                                }
                                            }
                                        }
                                    });
                                } else {
                                    playertp.runCommandAsync("/playsound block.false_permissions @s");
                                }

                            }
                        });
                    } else {
                        if (tpentity[teleporten].getComponent("minecraft:health").currentValue > 100) {
                            let selectedbtn = result.selection;

                            let objtp = world.scoreboard.getObjective("TpPlayer῁");
                            objtp = objtp.getScore(tpentity[teleporten]);

                            let tpTags = tpentity[teleporten].getTags().length;

                            let tpbuttons = [];
                            for (let i = 0; i <= tpTags; i++) {
                                if (!tpentityTags[i] == "") {
                                    if (tpentityTags[i].startsWith("῟", 0)) {
                                        let tpinfo = tpentityTags[i].split("῝");
                                        tpbuttons.push(tpentityTags[i]);
                                        let dimsymbol = "";
                                        if (tpinfo[4] == "overworld") {
                                            dimsymbol = "";
                                        } else if (tpinfo[4] == "nether") {
                                            dimsymbol = "";
                                        } else if (tpinfo[4] == "the_end") {
                                            dimsymbol = "";
                                        }
                                    }
                                }
                            }
                            let tpteleport = tpbuttons[selectedbtn].split("῝");

                            const xto = Math.trunc(tpteleport[1]);
                            const yto = Math.trunc(tpteleport[2]);
                            const zto = Math.trunc(tpteleport[3]);
                            const tpdim = world.getDimension(tpteleport[4]);
                            const entitytpto = tpdim.getEntities({
                                location: { x: xto, y: yto, z: zto },
                                maxDistance: 2,
                                type: "ox:teleportentity"
                            })[0]

                            if (!entitytpto?.getTags().includes("Private῁") || entitytpto?.getTags().includes("CanUse῁" + playertp.nameTag) || entitytpto?.getTags().includes("Owner῁" + playertp.nameTag)) {
                                tpentity[teleporten].runCommandAsync("/tag @s add Teleporting῁");
                                tpentity[teleporten].getComponent("minecraft:health").setCurrentValue(tpentity[teleporten].getComponent("minecraft:health").currentValue - 100);

                                tpentity[teleporten].runCommandAsync("/particle ox:tppar ~ ~-0.2 ~");
                                playertp.runCommandAsync("/playanimation @s animation.tpplayer ");
                                tpentity[teleporten].runCommandAsync("/playsound portal.trigger @a [r=7]");
                                playertp.runCommandAsync("/camera @s fade time 4 0.6 1");
                                system.runTimeout(() => {
                                    playertp.runCommandAsync("/effect @s levitation 4 1 true");
                                }, 6);
                                system.runTimeout(() => {
                                    playertp.runCommandAsync("/playsound tp.done @s");
                                    playertp.runCommandAsync("/particle ox:playertp ~ ~3 ~");
                                }, 55);
                                system.runTimeout(() => {

                                    tpentity[teleporten].runCommandAsync("/tag @s remove Teleporting῁");
                                    playertp.runCommandAsync('/execute as @e [type=ox:teleportentity,x=' + tpteleport[1] + ',y=' + tpteleport[2] + ',z=' + tpteleport[3] + ',r=2,c=1] run tag @s remove Teleporting῁');

                                    let ytpto = Math.pow(tpteleport[2], 1);
                                    ytpto = ytpto + 1;
                                    playertp.runCommandAsync("/execute in " + tpteleport[4] + " run tp @s " + tpteleport[1] + " " + ytpto + " " + tpteleport[3] + " 0 0");
                                    playertp.runCommandAsync("/playsound tp.done @s");
                                    playertp.runCommandAsync('tellraw @s {"rawtext":[{"text":" §l§fYou §dHave Been Teleported From §f' + tpentity[teleporten].nameTag + ' §dTo §f' + entitytpto?.nameTag + '"}]}');
                                }, 80);
                            } else {
                                playertp.runCommandAsync('/titleraw @s actionbar {"rawtext":[{"text":" §l§f' + tpentity[teleporten].nameTag + ' §cis §fPrivate §cYou Can Not Teleport To it !!"}]}');
                                playertp.runCommandAsync("/playsound respawn_anchor.deplete @s");
                            }
                        } else {
                            playertp.runCommandAsync('/titleraw @s actionbar {"rawtext":[{"text":" §l§f' + tpentity[teleporten].nameTag + ' §cDoes Not Have Enough §r §l§ePower §cTo Teleport You !!"}]}');
                            playertp.runCommandAsync("/playsound respawn_anchor.deplete @s");
                        }
                    }
                });
            }
        } else {
            if (!tptags.includes("Owner῁" + playertp.nameTag + "")) {
                const tpowner = tptags[0].split("῁");

                playertp.runCommandAsync('titleraw @s actionbar {"rawtext":[{"text":" §l§cThis §5TELEPORTATION §cis Private For §r§f§l§o' + tpowner[1] + '§r§c§l !!"}]}');
                playertp.runCommandAsync("playsound note.bass @s");
            }

            if (tptags.includes("Teleporting῁")) {
                playertp.runCommandAsync('titleraw @s actionbar {"rawtext":[{"text":" §l§cThis §5TELEPORTATION §cis Teleporting !!"}]}');
                playertp.runCommandAsync("playsound note.bass @s");
            }

        }
    } else if (blocktp.typeId === "ox:teleport_top" || blocktp.typeId === "ox:teleport") {
        const dimf = blocktp.dimension;

        let tpentityf = "";
        if (blocktp.typeId === "ox:teleport") {
            tpentityf = blocktp.dimension.getEntities({ location: blocktp.location, maxDistance: 0.8, type: 'ox:teleportentity' });
        } else {
            tpentityf = blocktp.dimension.getEntities({ location: blocktp.location, maxDistance: 2, type: 'ox:teleportentity' });
        }

        let teleportenf = "";
        if (!tpentityf.length == 0) {
            for (let i = 0; i <= tpentityf.length; i++) {
                if (tpentityf[i].typeId == "ox:teleportentity") {
                    teleportenf = "" + i;
                    break;
                }
            }
        }

        let dimoftpe = "";
        if (teleportenf != "") {
            if (tpentityf[teleportenf].dimension.id == "minecraft:overworld") {
                dimoftpe = "overworld";
            } else if (tpentityf[teleportenf].dimension.id == "minecraft:nether") {
                dimoftpe = "nether";
            } else if (tpentityf[teleportenf].dimension.id == "minecraft:the_end") {
                dimoftpe = "the_end";
            }
        }

        if (itemtp.typeId == "ox:tp_fuel" && !tpentityf[teleportenf].getTags().includes("Teleporting῁") || itemtp.typeId == "minecraft:dragon_breath" && !tpentityf[teleportenf].getTags().includes("Teleporting῁")) {

            if (tpentityf[teleportenf].getComponent("minecraft:health").currentValue < 1000) {
                if (itemtp.typeId == "ox:tp_fuel") {
                    playertp.runCommandAsync("/clear @s ox:tp_fuel -1 1");
                    tpentityf[teleportenf].getComponent("minecraft:health").setCurrentValue(tpentityf[teleportenf].getComponent("minecraft:health").currentValue + 50);
                    playertp.runCommandAsync('/titleraw @s actionbar {"rawtext":[{"text":"  §l§f' + tpentityf[teleportenf].nameTag + ' §eHas Been Charged §f50 §r ' + '\n' + '§l§eNow it is §f' + (tpentityf[teleportenf].getComponent("minecraft:health").currentValue - 1) + ' §eCharged"}]}');
                } else if (itemtp.typeId == "minecraft:dragon_breath") {
                    playertp.runCommandAsync("/clear @s dragon_breath -1 1");
                    tpentityf[teleportenf].getComponent("minecraft:health").setCurrentValue(tpentityf[teleportenf].getComponent("minecraft:health").currentValue + 25);
                    playertp.runCommandAsync('/titleraw @s actionbar {"rawtext":[{"text":"  §l§f' + tpentityf[teleportenf].nameTag + ' §eHas Been Charged §f25 §r ' + '\n' + '§l§eNow it is §f' + (tpentityf[teleportenf].getComponent("minecraft:health").currentValue - 1) + ' §eCharged"}]}');
                }
                playertp.runCommandAsync("/playsound tp.charge @a [r=5]");
                tpentityf[teleportenf].runCommandAsync("particle ox:charge ~ ~0.5 ~");
            } else {
                playertp.runCommandAsync("/playsound tp.fullcharged @s");
                playertp.runCommandAsync('titleraw @s actionbar {"rawtext":[{"text":"  §l§f' + tpentityf[teleportenf].nameTag + ' §eis Full of §r"}]}');
            }
        }

        if (itemtp.typeId == "ox:tppotion" && !playertp.hasTag("῟῝" + tpentityf[teleportenf].location.x + "῝" + tpentityf[teleportenf].location.y + "῝" + tpentityf[teleportenf].location.z + "῝" + dimoftpe)) {
            let playerTagsL = playertp.getTags().length;
            let playerTags = playertp.getTags();

            for (let i = 0; i <= playerTagsL; i++) {
                if (!playerTags[i] == "") {
                    if (playerTags[i].startsWith("῟", 0)) {
                        playertp.removeTag(playerTags[i]);
                    }
                }
            }

            playertp.addTag("῟῝" + tpentityf[teleportenf].location.x + "῝" + tpentityf[teleportenf].location.y + "῝" + tpentityf[teleportenf].location.z + "῝" + dimoftpe);
            playertp.runCommandAsync("/playsound mob.witch.drink @s");
            tpentityf[teleportenf].runCommandAsync("/particle minecraft:endrod ~ ~1 ~");
            playertp.runCommandAsync('titleraw @s actionbar {"rawtext":[{"text":" §l§fYou §dHave Been Linked With §f' + tpentityf[teleportenf].nameTag + '"}]}');
        } else if (itemtp.typeId == "ox:tppotion" && playertp.hasTag("῟῝" + tpentityf[teleportenf].location.x + "῝" + tpentityf[teleportenf].location.y + "῝" + tpentityf[teleportenf].location.z + "῝" + dimoftpe)) {
            playertp.runCommandAsync("playsound note.bass @s");
            playertp.runCommandAsync('titleraw @s actionbar {"rawtext":[{"text":" §l§fYou §dAlready Linked With §f' + tpentityf[teleportenf].nameTag + '"}]}');
        }
    }
});
///////////////////////////////////////////

///////////////////////////////////////////
